unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, IdCustomTCPServer, IdTCPServer, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdContext, StdCtrls,
  IdIOHandler, IdIOHandlerStream, IdIntercept, IdGlobal,
  IdCompressionIntercept;

type
  TForm1 = class(TForm)
    TCPClient: TIdTCPClient;
    TCPServeur: TIdTCPServer;
    HorlogeEtat: TTimer;
    HorlogeLectureClient: TTimer;
    Panel2: TPanel;
    IdCompressionIntercept: TIdCompressionIntercept;
    GroupBox1: TGroupBox;
    BoutonServeur_Etat: TButton;
    BoutonServeur_DeconnecterClients: TButton;
    EditServeur_EnvoyerCommande: TEdit;
    BoutonServeur_EnvoyerCommande: TButton;
    BoutonServeur_Fichier: TButton;
    EditServeur_Fichier: TEdit;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    BoutonClient_Client: TButton;
    EditClient_Fichier: TEdit;
    BoutonClient_Fichier: TButton;
    EditClient_MotClient: TEdit;
    BoutonClient_Inverser: TButton;
    EditClient_MotServeur: TEdit;
    Log: TMemo;
    Label2: TLabel;
    BoutonServeur_FichierSelection: TButton;
    BoutonClient_FichierSelection: TButton;
    OpenDialog1: TOpenDialog;
    Label3: TLabel;
    Label4: TLabel;
    procedure HorlogeEtatTimer(Sender: TObject);
    procedure TCPServeurExecute(AContext: TIdContext);
    procedure BoutonServeur_EtatClick(Sender: TObject);
    procedure BoutonClient_ClientClick(Sender: TObject);
    procedure BoutonServeur_DeconnecterClientsClick(Sender: TObject);
    procedure BoutonServeur_EnvoyerCommandeClick(Sender: TObject);
    procedure TCPServeurConnect(AContext: TIdContext);
    procedure TCPServeurDisconnect(AContext: TIdContext);
    procedure HorlogeLectureClientTimer(Sender: TObject);
    procedure BoutonClient_FichierClick(Sender: TObject);
    procedure BoutonClient_InverserClick(Sender: TObject);
    procedure BoutonServeur_FichierClick(Sender: TObject);
    procedure BoutonServeur_FichierSelectionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


// Fonction permettant de savoir si le client TCP est connect au serveur
function IsTCPClientConnected(IdTCPClient: TIdTCPClient): bool;
begin
     result:=IdTCPClient.Connected and Assigned(IdTCPClient.Intercept.Connection);
end;

// Horloge de contrle de l'tat du client et du serveur
procedure TForm1.HorlogeEtatTimer(Sender: TObject);
begin
     if IsTCPClientConnected(TCPClient) then GroupBox2.Caption:='Client Connect' else GroupBox2.Caption:='Client Dconnect';
     if TCPServeur.Active then GroupBox1.Caption:='Serveur Connect' else GroupBox1.Caption:='Serveur Dconnect';
end;

// Arrt / Lancement du serveur
procedure TForm1.BoutonServeur_EtatClick(Sender: TObject);
begin
     (Sender as TButton).Enabled:=false;
     TCPServeur.Active:=not TCPServeur.Active;
     (Sender as TButton).Enabled:=true;
     HorlogeEtatTimer(nil);
end;

// Arrt / Connexion du client
procedure TForm1.BoutonClient_ClientClick(Sender: TObject);
begin
     (Sender as TButton).Enabled:=false;
     try
        if IsTCPClientConnected(TCPClient) then TCPCLient.Disconnect else TCPClient.Connect;
     except
     end;
     (Sender as TButton).Enabled:=true;
     HorlogeEtatTimer(nil);
end;

// Dconnexion de tous les clients du serveur
procedure TForm1.BoutonServeur_DeconnecterClientsClick(Sender: TObject);
var i: integer;
begin
   try
      if TCPServeur.Active then
       with TCPServeur.Contexts.LockList do
        try
           for i:=0 to Count-1 do
           begin
                if TIdContext(Items[i]).Connection.Connected then
                begin
                     TIdContext(Items[i]).Connection.IOHandler.Close;
                     TIdContext(Items[i]).Connection.Disconnect;
                end;
           end;
        finally
           TCPServeur.Contexts.UnlockList;
        end;
     except
     end;
     HorlogeEtatTimer(nil);
end;

// Envoi d'un texte du serveur au client
procedure TForm1.BoutonServeur_EnvoyerCommandeClick(Sender: TObject);
var i: integer;
begin
    try
        if TCPServeur.Active then
        with TCPServeur.Contexts.LockList do
        try
           for i:=0 to Count-1 do
           begin
                if TIdContext(Items[i]).Connection.Connected then
                begin
                     TIdContext(Items[i]).Connection.IOHandler.WriteLn(EditServeur_EnvoyerCommande.Text, TIdTextEncoding.UTF8);
                end;
           end;
        finally
           TCPServeur.Contexts.UnlockList;
        end;
     except
     end;
end;

// Boucle d'excution du serveur
procedure TForm1.TCPServeurExecute(AContext: TIdContext);
 function Inverser(Chaine: string): string;
 var i: integer;
 begin
      result:=''; for i:=length(Chaine) downto 1 do result:=result+Chaine[i];
 end;
var Line, Cmd: string;
    FileStream: TFileStream;
    Size: cardinal;
begin
     with AContext.Connection.IOHandler do
     begin
          Line:=ReadLn(TIdTextEncoding.UTF8);
          Cmd:=Fetch(Line);
          if Cmd='CLIENT_SEND_FILE' then
          begin
               Line:=Readln(TIdTextEncoding.UTF8);
               Size:=StrToInt(Fetch(Line));
               FileStream:=TFileStream.Create(ExtractFilePath(ParamStr(0))+Line, fmCreate);
               FileStream.Size:=Size;
               FileStream.Position:=0;
               ReadStream(FileStream, FileStream.Size);
               Writeln('FILE RECEIVED BY SERVER - NAME : '+Line+' - SIZE : '+inttostr(FileStream.Size));
               FileStream.Free;
          end
          else
          if Cmd='INV' then WriteLn('201 '+Inverser(Line), TIdTextEncoding.UTF8)
          else
          if Cmd='CLIENT_ASK_FILE' then
          begin
               if FileExists(Line) then
               begin
                    try
                       FileStream:=TFileStream.Create(Line, fmOpenRead);
                       Writeln('202 '+Line, TIdTextEncoding.UTF8);
                       FileStream.Position:=0;
                       AContext.Connection.IOHandler.Writeln(inttostr(FileStream.Size));
                       AContext.Connection.IOHandler.Write(FileStream, FileStream.Size);
                       FileStream.Free;
                    except
                       Writeln('204 FILE UNREACHEABLE');
                    end;
               end
               else Writeln('203 FILE NOT FOUND');
          end
          else Writeln('404 ERROR');
     end;
end;

// Connexion d'un client au serveur : gestion des donnes compresses depuis le serveur
procedure TForm1.TCPServeurConnect(AContext: TIdContext);
begin
      with (AContext.Connection) do
      begin
          Intercept := TIdCompressionIntercept.Create(nil); //Crer le "dcompresseur"
          TIdCompressionIntercept(Intercept).CompressionLevel := 9; //Niveau de compression
      end;
end;

// Dconnexion d'un client au serveur : libration du compresseur de donnes
procedure TForm1.TCPServeurDisconnect(AContext: TIdContext);
begin
  with (AContext.Connection) do 
  begin
    if Assigned(Intercept) then //Assign ?
    begin
       Intercept.Free; //on libre...
       Intercept := nil; 
    end;
  end;
end;

// Lecture priodique de la "bote aux lettres" du Client
procedure TForm1.HorlogeLectureClientTimer(Sender: TObject);
var Line, Chaine: string;
    Size: cardinal;
    MS: TMemoryStream;
begin
     (Sender as TTImer).Enabled:=false;
     if IsTCPClientConnected(TCPClient) and Assigned(TCPCLient.IOHandler) and not TCPCLient.IOHandler.InputBufferIsEmpty then
     try
        Line:=TCPCLient.IOHandler.Readln(TIdTextEncoding.UTF8);
        Log.Lines.Insert(0, Line);
        Chaine:=Fetch(Line);
        if Chaine='CLIENT_ASK_FILE' then
        begin
             TCPClient.SendCmd(Chaine+' '+Line, [202, 203, 204], TIdTextEncoding.UTF8);
             if TCPClient.LastCmdResult.NumericCode=202 then
             try
                Size:=StrToInt(TCPClient.IOHandler.ReadLn(TIdTextEncoding.UTF8));
                MS:=TMemoryStream.Create;
                TCPClient.IOHandler.ReadStream(MS, Size);
                MS.SaveToFile(ExtractFilePath(ParamStr(0))+ExtractFileName(Line));
                Log.Lines.Insert(0, 'FILE RECEIVED BY CLIENT - NAME : '+ExtractFileName(Line)+' - SIZE : '+inttostr(MS.Size));
                MS.Free;
             except
             end
             else
             Log.Lines.Insert(0, Trim(TCPClient.LastCmdResult.Text.Text));
        end;
     except
     end;
     (Sender as TTImer).Enabled:=true;
end;

// Envoi d'un fichier du client au serveur
procedure TForm1.BoutonClient_FichierClick(Sender: TObject);
var MS: TMemoryStream;
begin
     if IsTCPClientConnected(TCPClient) and Assigned(TCPClient.IOHandler) and FileExists(EditClient_Fichier.Text) then
     begin
          MS:=TMemoryStream.Create;
          MS.LoadFromFile(EditClient_Fichier.Text);
          MS.Position:=0;
          TCPClient.IOHandler.Writeln('CLIENT_SEND_FILE');
          TCPClient.IOHandler.Writeln(inttostr(MS.Size)+' '+ExtractFileName(EditClient_Fichier.Text));
          TCPClient.IOHandler.Write(MS, MS.Size);
          MS.Free;
     end;
end;

// Envoi d'une commande d'inversion de chane au serveur et attente du rsultat
procedure TForm1.BoutonClient_InverserClick(Sender: TObject);
var Lines: TStringList;
begin
     if IsTCPClientConnected(TCPClient) then
     begin
          Lines:=TStringList.Create;
          try TCPClient.SendCmd('INV '+EditClient_MotClient.Text, 201, TIdTextEncoding.UTF8); except end;
          EditClient_MotServeur.Text:=TCPClient.LastCmdResult.Text.Text;
          Lines.Free;
     end;
end;

// Envoi d'un fichier du serveur  tous les clients
procedure TForm1.BoutonServeur_FichierClick(Sender: TObject);
var i: integer;
begin
     if TCPServeur.Active then
     with TCPServeur.Contexts.LockList do
     try
        for i:=0 to Count-1 do
        begin
             if TIdContext(Items[i]).Connection.Connected then
                TIdContext(Items[i]).Connection.IOHandler.Writeln('CLIENT_ASK_FILE '+EditServeur_Fichier.Text, TIdTextEncoding.UTF8);
        end;
     finally
        TCPServeur.Contexts.UnlockList;
     end;
     {
     Le fait d'intervenir  l'intrieur du LockList ralentit le fonctionnement du serveur tant donn qu'il est thread.
     Il faut donc limiter les actions durant le LockList / UnlockList.

     Il serait possible d'utiliser Write(Stream....) pour envoyer un fichier directement, mais pour cette mme raison, le temps
     serait considrablement long.

     Une alternative consiste  :
     1. Envoyer un simple texte au client pour le prvenir qu'un fichier est prt  lui tre envoy
     2. Le client lance sa requte de demande de fichier
     3. La requte est traite dans le OnExecute du serveur (l o les actions du serveurs doivent s'excuter)
     4. Le fichier est transmis au client

     D'autres mthodes sont les bienvenues... !
     }
end;

// Slection d'un fichier
procedure TForm1.BoutonServeur_FichierSelectionClick(Sender: TObject);
begin
     if OpenDialog1.Execute then
     begin
          if Sender=BoutonServeur_FichierSelection then EditServeur_Fichier.Text:=OpenDialog1.FileName
                                                   else EditClient_Fichier.Text:=OpenDialog1.FileName;
     end;
end;

// Dfinition du niveau de compression du client
procedure TForm1.FormCreate(Sender: TObject);
begin IdCompressionIntercept.CompressionLevel:=9; end;

end.
